-- Perform cleanup


-- Move the Middle and Last Name values to their appropriate fields
UPDATE SalesContact_STAGE
SET FirstName = SUBSTRING(FirstName, 1, CHARINDEX(' ', FirstName))  
	, MiddleName = CASE WHEN CHARINDEX(' ', FirstName, CHARINDEX(' ', FirstName) + 1) > 0 
					THEN SUBSTRING(FirstName
						, CHARINDEX(' ', FirstName) + 1
						, CHARINDEX(' ', FirstName, CHARINDEX(' ', FirstName) + 1) - CHARINDEX(' ', FirstName) - 1)
					ELSE NULL END
	, LastName = SUBSTRING(FirstName, LEN(FirstName) - CHARINDEX(' ', REVERSE(FirstName)) + 1, CHARINDEX(' ', REVERSE(FirstName)))
WHERE LastName = '' OR LastName IS NULL

-- Validate the e-mail address format.
;WITH t1 AS
(
	SELECT *
	, CASE WHEN EmailAddress LIKE '%_@_%_.__%' 
	  THEN 1
	  ELSE 0
	  END EmailValidated
	FROM SalesContact_STAGE
	WHERE LEN(EmailAddress) > 0
)
UPDATE t1
SET EmailAddress = NULL
	, Comments = ISNULL(Comments, '')
				+ CASE WHEN LEN(Comments) > 0 THEN '; ' ELSE '' END
				+ 'Invalid e-mail address: ' 
				+ EmailAddress
WHERE EmailValidated = 0	
